#line 1 "D:/Clicks/magneto6_click/SW/PIC32/driver.c"
#line 1 "d:/clicks/magneto6_click/sw/pic32/driver.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic32/include/stdint.h"




typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 57 "d:/clicks/magneto6_click/sw/pic32/driver.h"
typedef struct
{
 int16_t x;
 int16_t y;
 int16_t z;
}magneto6_axes_t;
#line 73 "d:/clicks/magneto6_click/sw/pic32/driver.h"
void magneto6_generic_write ( uint8_t reg_adr, uint8_t trigger, uint8_t tx_data );
#line 84 "d:/clicks/magneto6_click/sw/pic32/driver.h"
uint8_t magneto6_generic_read ( uint8_t reg_adr, uint8_t trigger );
#line 91 "d:/clicks/magneto6_click/sw/pic32/driver.h"
uint8_t magneto6_get_hw_ver ( void );
#line 98 "d:/clicks/magneto6_click/sw/pic32/driver.h"
uint8_t magneto6_get_type ( void );
#line 105 "d:/clicks/magneto6_click/sw/pic32/driver.h"
uint8_t magneto6_get_id ( void );
#line 112 "d:/clicks/magneto6_click/sw/pic32/driver.h"
int16_t magneto6_get_temp_value ( void );
#line 121 "d:/clicks/magneto6_click/sw/pic32/driver.h"
int16_t magneto6_get_axis_value ( uint8_t axis );
#line 127 "d:/clicks/magneto6_click/sw/pic32/driver.h"
void magneto6_get_axes_value ( magneto6_axes_t *axes );
#line 1 "d:/clicks/magneto6_click/sw/pic32/mcu_driver.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic32/include/stdint.h"
#line 19 "d:/clicks/magneto6_click/sw/pic32/mcu_driver.h"
void define_cs ( uint8_t io_state );
#line 26 "d:/clicks/magneto6_click/sw/pic32/mcu_driver.h"
void define_int ( uint8_t io_state );
#line 33 "d:/clicks/magneto6_click/sw/pic32/mcu_driver.h"
void log_init ( void );
#line 40 "d:/clicks/magneto6_click/sw/pic32/mcu_driver.h"
void log_text ( uint8_t *txt_data );
#line 47 "d:/clicks/magneto6_click/sw/pic32/mcu_driver.h"
void log_line ( uint8_t *txt_data );
#line 54 "d:/clicks/magneto6_click/sw/pic32/mcu_driver.h"
void dev_i2c_init ( void );
#line 59 "d:/clicks/magneto6_click/sw/pic32/mcu_driver.h"
void dev_i2c_start ( void );
#line 64 "d:/clicks/magneto6_click/sw/pic32/mcu_driver.h"
void dev_i2c_stop ( void );
#line 71 "d:/clicks/magneto6_click/sw/pic32/mcu_driver.h"
void dev_i2c_write ( uint8_t tx_byte );
#line 78 "d:/clicks/magneto6_click/sw/pic32/mcu_driver.h"
uint8_t dev_i2c_read ( void );
#line 28 "D:/Clicks/magneto6_click/SW/PIC32/driver.c"
void magneto6_generic_write ( uint8_t reg_adr, uint8_t trigger, uint8_t tx_data )
{
 uint8_t temp_data;

 temp_data = reg_adr &  0x1F ;
 temp_data |= trigger <<  5 ;

 dev_i2c_start( );
 dev_i2c_write(  0x6A  );
 dev_i2c_write( temp_data );
 dev_i2c_write( tx_data );
 dev_i2c_stop( );
}

uint8_t magneto6_generic_read ( uint8_t reg_adr, uint8_t trigger )
{
 uint8_t temp_data;

 temp_data = reg_adr &  0x1F ;
 temp_data |= trigger <<  5 ;

 dev_i2c_start( );
 dev_i2c_write(  0x6B  );
 dev_i2c_write( temp_data );
 temp_data = dev_i2c_read( );
 dev_i2c_stop( );

 return temp_data;
}

uint8_t magneto6_get_id ( void )
{
 uint8_t id;
 id = magneto6_generic_read(  0x05 ,
  0x00  );
 id >>=  4 ;
 id &=  0x03 ;
 return id;
}

uint8_t magneto6_get_type ( void )
{
 uint8_t dev_type;
 dev_type = magneto6_generic_read(  0x16 ,
  0x00  );
 dev_type >>=  4 ;
 dev_type &=  0x03 ;
 return dev_type;
}

uint8_t magneto6_get_hw_ver ( void )
{
 uint8_t hw_ver;
 hw_ver = magneto6_generic_read(  0x16 ,
  0x00  );
 hw_ver &=  0x0F ;
 return hw_ver;
}

int16_t magneto6_get_temp_value ( void )
{
 int16_t temperature_value = 0;
 uint8_t temp_read;

 temp_read = magneto6_generic_read(  0x03 ,
  0x00  );
 temperature_value = temp_read;
 temperature_value <<=  4 ;
 if ( 0 != ( temp_read &  0x80  ) )
 {
 temperature_value |=  0xF000 ;
 }
 temp_read = magneto6_generic_read(  0x05 ,
  0x00  );
 temp_read >>=  4 ;
 temp_read &=  0x0C ;
 temperature_value |= temp_read;

 temperature_value -=  1180 ;
 temperature_value *=  0.24 ;
 temperature_value +=  25 ;

 return temperature_value;
}

int16_t magneto6_get_axis_value ( uint8_t axis )
{
 int16_t axis_value;
 uint8_t msb_read;
 uint8_t lsb_read;
 int16_t signed_val =  -2048 ;

 switch ( axis )
 {
 case  0xAA :
 {
 msb_read = magneto6_generic_read(  0x00 ,
  0x00  );
 lsb_read = magneto6_generic_read(  0x04 ,
  0x00  );
 lsb_read >=  4 ;
 break;
 }
 case  0xBB :
 {
 msb_read = magneto6_generic_read(  0x01 ,
  0x00  );
 lsb_read = magneto6_generic_read(  0x04 ,
  0x00  );
 break;
 }
 case  0xCC :
 {
 msb_read = magneto6_generic_read(  0x02 ,
  0x00  );
 lsb_read = magneto6_generic_read(  0x05 ,
  0x00  );
 break;
 }
 default:
 {
 return  0xFFFF ;
 }
 }

 if ( 0 == ( msb_read &  0x80  ) )
 {
 signed_val =  0 ;
 }
 msb_read &=  0x7F ;
 lsb_read &=  0x0F ;
 axis_value = msb_read;
 axis_value <<=  4 ;
 axis_value |= lsb_read;
 axis_value += signed_val;
 return axis_value;
}

void magneto6_get_axes_value ( magneto6_axes_t *axes )
{
 axes->x = magneto6_get_axis_value(  0xAA  );
 axes->y = magneto6_get_axis_value(  0xBB  );
 axes->z = magneto6_get_axis_value(  0xCC  );
}
