#line 1 "D:/Clicks/magneto6_click/SW/PIC32/magneto6.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic32/include/stdint.h"




typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 1 "d:/clicks/magneto6_click/sw/pic32/mcu_driver.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic32/include/stdint.h"
#line 19 "d:/clicks/magneto6_click/sw/pic32/mcu_driver.h"
void define_cs ( uint8_t io_state );
#line 26 "d:/clicks/magneto6_click/sw/pic32/mcu_driver.h"
void define_int ( uint8_t io_state );
#line 33 "d:/clicks/magneto6_click/sw/pic32/mcu_driver.h"
void log_init ( void );
#line 40 "d:/clicks/magneto6_click/sw/pic32/mcu_driver.h"
void log_text ( uint8_t *txt_data );
#line 47 "d:/clicks/magneto6_click/sw/pic32/mcu_driver.h"
void log_line ( uint8_t *txt_data );
#line 54 "d:/clicks/magneto6_click/sw/pic32/mcu_driver.h"
void dev_i2c_init ( void );
#line 59 "d:/clicks/magneto6_click/sw/pic32/mcu_driver.h"
void dev_i2c_start ( void );
#line 64 "d:/clicks/magneto6_click/sw/pic32/mcu_driver.h"
void dev_i2c_stop ( void );
#line 71 "d:/clicks/magneto6_click/sw/pic32/mcu_driver.h"
void dev_i2c_write ( uint8_t tx_byte );
#line 78 "d:/clicks/magneto6_click/sw/pic32/mcu_driver.h"
uint8_t dev_i2c_read ( void );
#line 1 "d:/clicks/magneto6_click/sw/pic32/driver.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic32/include/stdint.h"
#line 57 "d:/clicks/magneto6_click/sw/pic32/driver.h"
typedef struct
{
 int16_t x;
 int16_t y;
 int16_t z;
}magneto6_axes_t;
#line 73 "d:/clicks/magneto6_click/sw/pic32/driver.h"
void magneto6_generic_write ( uint8_t reg_adr, uint8_t trigger, uint8_t tx_data );
#line 84 "d:/clicks/magneto6_click/sw/pic32/driver.h"
uint8_t magneto6_generic_read ( uint8_t reg_adr, uint8_t trigger );
#line 91 "d:/clicks/magneto6_click/sw/pic32/driver.h"
uint8_t magneto6_get_hw_ver ( void );
#line 98 "d:/clicks/magneto6_click/sw/pic32/driver.h"
uint8_t magneto6_get_type ( void );
#line 105 "d:/clicks/magneto6_click/sw/pic32/driver.h"
uint8_t magneto6_get_id ( void );
#line 112 "d:/clicks/magneto6_click/sw/pic32/driver.h"
int16_t magneto6_get_temp_value ( void );
#line 121 "d:/clicks/magneto6_click/sw/pic32/driver.h"
int16_t magneto6_get_axis_value ( uint8_t axis );
#line 127 "d:/clicks/magneto6_click/sw/pic32/driver.h"
void magneto6_get_axes_value ( magneto6_axes_t *axes );
#line 32 "D:/Clicks/magneto6_click/SW/PIC32/magneto6.c"
static uint8_t demo_type;
static uint8_t temp_data;
static char demo_txt[ 30 ];
static int16_t sens_data;
static magneto6_axes_t axes_val;

void sys_init ( void );

void app_cfg ( uint8_t app_type );

void app_task ( void );

void main( )
{
 sys_init( );
 app_cfg(  2  );

 for ( ; ; )
 {
 app_task( );
 }
}

void sys_init ( void )
{
 define_cs(  0  );
 define_int(  1  );
  LATA4_bit  = 0;
 dev_i2c_init( );
 Delay_ms( 100 );
 log_init( );
 Delay_ms( 100 );
 log_line( " - Init -" );
}

void app_cfg ( uint8_t app_type )
{
 demo_type = app_type;

 magneto6_generic_write(  0x10 ,
  0x00 ,
  0xC0  );
 magneto6_generic_write(  0x11 ,
  0x00 ,
  0x04  );

 temp_data = magneto6_get_id( );
 ByteToStr( temp_data, demo_txt );
 log_text( " ID: " );
 Ltrim( demo_txt );
 log_line( demo_txt );
 Delay_ms( 100 );
 temp_data = magneto6_get_type( );
 ByteToStr( temp_data, demo_txt );
 log_text( " Type: " );
 Ltrim( demo_txt );
 log_line( demo_txt );
 Delay_ms( 100 );
 temp_data = magneto6_get_hw_ver( );
 ByteToStr( temp_data, demo_txt );
 Ltrim( demo_txt );
 log_text( " HW version: " );
 log_line( demo_txt );
 Delay_ms( 100 );

 switch ( demo_type )
 {
 case  1 :
 magneto6_generic_write(  0x10 ,
  0x00 ,
  0x40  );
 break;
 case  2 :
 magneto6_generic_write(  0x10 ,
  0x00 ,
  0x80  );
 break;
 default:
 log_line( " - ERROR - " );
 for( ; ; );
 }

 log_line( " - Task - " );
 Delay_ms( 100 );
}

void app_task ( void )
{
 if (  1  == demo_type )
 {
 sens_data = magneto6_get_temp_value( );
 IntToStr( sens_data, demo_txt );
 Ltrim( demo_txt );
 log_text( " Temperature: " );
 log_line( demo_txt );
 }
 else
 {
 magneto6_get_axes_value( &axes_val );
 IntToStr( axes_val.x, demo_txt );
 Ltrim( demo_txt );
 log_text( " X: " );
 log_line( demo_txt );

 IntToStr( axes_val.y, demo_txt );
 Ltrim( demo_txt );
 log_text( " Y: " );
 log_line( demo_txt );

 IntToStr( axes_val.z, demo_txt );
 Ltrim( demo_txt );
 log_text( " Z: " );
 log_line( demo_txt );
 }

 log_line( "----------------------" );
 Delay_ms( 1000 );
}
