#include "mcu_driver.h"
#include "cfg_communication.h"

#define DUMMY 0x00

void define_cs ( uint8_t io_state )
{
    AD1PCFG = 0xFFFF;      // Configure AN pins as digital I/O
    JTAGEN_bit = 0;        // Disable JTAG
    TRISA4_bit = io_state;//IEN define
}

void define_int ( uint8_t io_state )
{
    AD1PCFG = 0xFFFF;      // Configure AN pins as digital I/O
    JTAGEN_bit = 0;        // Disable JTAG
    TRISE8_bit = io_state;//INT define
}

void log_init ( void )
{
    UART2_Init( LOG_BAUD );
}

void log_text ( uint8_t *txt_data )
{
    UART_Write_Text( txt_data );
}

void log_line ( uint8_t *txt_data )
{
    UART_Write_Text( txt_data );
    UART_Write( 13 );
    UART_Write( 10 );
}

void dev_i2c_init ( void )
{
    I2C2_Init( I2C_SPEED );
}

void dev_i2c_start ( void )
{
    I2C2_Start(  );
}

void dev_i2c_stop ( void )
{
    I2C2_Stop(  );
}

void dev_i2c_write ( uint8_t tx_byte )
{
    I2C2_Write( tx_byte );
}

uint8_t dev_i2c_read ( void )
{
    return I2C2_Read( _I2C_NACK );
}